Panda3D

Functions
billboardEffect.cxx File Reference

PANDA 3D SOFTWARE Copyright (c) Carnegie Mellon University. More...

`#include "billboardEffect.h"`
`#include "cullTraverser.h"`
`#include "cullTraverserData.h"`
`#include "nodePath.h"`
`#include "look_at.h"`
`#include "bamReader.h"`
`#include "bamWriter.h"`
`#include "datagram.h"`
`#include "datagramIterator.h"`

Go to the source code of this file.

## Functions
| CPT (RenderEffect) BillboardEffect
| Constructs a new BillboardEffect object with the indicated properties. More...
| CPT (TransformState) BillboardEffect
| Preprocesses the accumulated transform that is about to be applied to (or through) this node due to a flatten operation. More...

## Detailed Description

PANDA 3D SOFTWARE Copyright (c) Carnegie Mellon University.

All rights reserved.

All use of this software is subject to the terms of the revised BSD license. You should have received a copy of this license along with this source code in a file named "LICENSE."

Author
  drose

Date
  2002-03-14

Definition in file billboardEffect.cxx.

## Function Documentation

## ◆ CPT() [1/2]

CPT | ( | RenderEffect |  | ) |

Constructs a new BillboardEffect object with the indicated properties.

Definition at line 29 of file billboardEffect.cxx.

## ◆ CPT() [2/2]

CPT | ( | TransformState |  | ) |

Preprocesses the accumulated transform that is about to be applied to (or through) this node due to a flatten operation.

The returned value will be used instead.

Should be overridden by derived classes to return true if cull_callback() has been defined. Otherwise, returns false to indicate cull_callback() does not need to be called for this effect during the cull traversal.

If has_cull_callback() returns true, this function will be called during the cull traversal to perform any additional operations that should be performed at cull time. This may include additional manipulation of render state or additional visible/invisible decisions, or any other arbitrary operation.

At the time this function is called, the current node's transform and state have not yet been applied to the net_transform and net_state. This callback may modify the node_transform and node_state to apply an effective change to the render state at this level.

Should be overridden by derived classes to return true if adjust_transform() has been defined, and therefore the RenderEffect has some effect on the node's apparent local and net transforms.

Performs some operation on the node's apparent net and/or local transforms. This will only be called if has_adjust_transform() is redefined to return true.

Both parameters are in/out. The original transforms will be passed in, and they may (or may not) be modified in-place by the RenderEffect.

Intended to be overridden by derived BillboardEffect types to return a unique number indicating whether this BillboardEffect is equivalent to the other one.

This should return 0 if the two BillboardEffect objects are equivalent, a number less than zero if this one should be sorted before the other one, and a number greater than zero otherwise.

This will only be called with two BillboardEffect objects whose get_type() functions return the same.

Computes the billboard operation given the parent's net transform and the camera transform.

The result is applied to node_transform, which is modified in-place.

Tells the BamReader how to create objects of type BillboardEffect.

Definition at line 59 of file billboardEffect.cxx.